package
{
	import flash.display.*;
	import flash.events.*;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import gs.TweenMax;
	import gs.easing.*;
	
	public class FlashiPhone extends MovieClip
	{
		private var __iPhone:DragThrow;
		private var __xmlContent:XMLList;
		private var __imgsToLoad:int		= 0;
		private var __imgsLoaded:int		= 0;
		private var __loaders:Array			= [];
		private var __menuloaders:Array		= [];
		private var __menuShowing:Boolean	= true;

		// ______________________________________________
		// PUBLIC
		
		// SETUP MAIN CLASS
		public function FlashiPhone()
		{
			setup();
		}
		
		
		// ______________________________________________
		// PRIVATE
		
		// SETUP THE MAIN DRAG AND THROW FUNCTIONALITY
		// AND START TO LOAD THE CONTENT XML FILE
		private function setup(e:Event=null):void
		{
			// setup iPhone drag and throw functionality
			__iPhone					= new DragThrow();
			__iPhone.contentMC			= iPhoneMC.holder_mc.content_mc;
			__iPhone.width				= 435;
			__iPhone.height				= 290;
			__iPhone.counterHolderMC	= iPhoneMC.counter_mc;
			__iPhone.counterMC			= CircleMC;
			__iPhone.theStage			= stage;
			
			// disable events
			iPhoneMC.shadow_mc.mouseEnabled	= false;
			
			// load xml content
			loadXML("content.xml", xmlLoaded);
			
			// setup stage align and listeners
			stage.align		= "TL";
			stage.scaleMode	= "noScale";
			stage.addEventListener( Event.RESIZE, resizeHandler );
			resizeHandler();
		}
		
		// XML LOADED
		private function xmlLoaded(e:Event):void
		{
			// set XML
			var xml:XML		= new XML(e.target.data);
			__xmlContent	= xml.section;
			
			// load the main menu system
			createMenu();
		}
		
		
		
		
		// MAIN MENU
		// LOOP THROUGH THE LOADED XML CONTENT AND CREATE A FONT END MENU SYSTEM FOR NAVIIGATING TO THE CONTENT SECTIONS
		private function createMenu():void
		{
			// set orig position marker for the main menu
			menuMC.ox	= menuMC.x;
			
			// setup home button
			iPhoneMC.home_but.addEventListener( MouseEvent.MOUSE_DOWN, checkMenu );
			
			// load menu items
			for (var i:uint=0; i<__xmlContent.length(); i++)
			{
				// create holder movie for content
				var MC:MovieClip	= new MovieClip();
				
				// load image and add to menu loaders array so we can get rid of it easily later on
				var l:Loader	= loader(__xmlContent[i].@button, showImg);
				__menuloaders.push(l);
				
				// set props on main menu buttons
				// set button mode to true so this movie acts as a button when rolled over
				// set a refrence to the position of this clip in the XML structure, this will be used for loaded content later on
				MC.buttonMode	= true;
				MC.num			= i;
				
				// set mouse events
				MC.addEventListener( MouseEvent.MOUSE_OVER, menuOver );
				MC.addEventListener( MouseEvent.MOUSE_OUT, menuOut );
				MC.addEventListener( MouseEvent.MOUSE_DOWN, menuDown );
				
				// add to display
				MC.addChild(l);
				menuMC.holder_mc.addChild(MC);
			}
		}
		
		// SHOW THE LOADED IMAGE
		private function showImg(e:Event):void
		{
			var MC:MovieClip	= MovieClip(e.target.content.parent.parent);
				
			// set props
			MC.alpha		= 0;
			MC.x			= MC.num * MC.width;		// use the number reference we stored for positioning this movie
			MC.y			= -MC.height/2;				// center the movie position
			MC.oy			= MC.y;						// keep a reference to the default position
			
			// animate movie
			TweenMax.to(MC, .5, { alpha: 1 });
		}
		
		
		
		
		
		// CHECK TO SEE IF THE MAIN MENU SYSTEM SHOULD BE SHOWN OR HIDDEN WHEN
		// THE IPHONE HOME BUTTON IS CLICKED
		private function checkMenu(e:MouseEvent=null):void
		{
			// if the menu is already showing then hide it, else show it
			if (__menuShowing)	hideMenu();
			else				showMenu();
		}
		
		// REVEAL THE MAIN MENU SYSTEM
		private function showMenu():void
		{
			// animate menu into view
			__menuShowing	= true;
			TweenMax.to(menuMC, 1, { x: menuMC.ox, visible: true, ease: Expo.easeOut });
		}
		
		// HIDE THE MAIN MENU SYSTEM
		private function hideMenu():void
		{
			// animate menu out of view
			__menuShowing	= false;
			TweenMax.to(menuMC, 1, { x: menuMC.ox-menuMC.width, visible: false, ease: Expo.easeOut });	
		}
		
		// HIGHLIGHT THE MENU ITEM WHEN ROLLED OVER
		private function menuOver(e:MouseEvent):void
		{
			// do rollover effect and start a loop for tracking the mouse position for additional rollover effect
			var MC:MovieClip	= MovieClip(e.currentTarget);
			TweenMax.to(MC, .3, { colorMatrixFilter:{ brightness: .6, contrast: 1.2 }});
			trackMouse(MC);
		}
		
		// SET THE MENU ITEM BACK TO NORMAL WHEN WE HAVE ROLLED OUT
		private function menuOut(e:MouseEvent):void
		{
			// set menu item back to normal and set its position back to normal
			var MC:MovieClip	= MovieClip(e.currentTarget);
			TweenMax.to(MC, 1, { colorMatrixFilter:{ brightness: 1, contrast: 1 }});
			trackMouse(MC, false);
		}
		
		// MENU ITEM CLICKED
		private function menuDown(e:MouseEvent):void
		{
			// used the stored number value in this movie to be used in loading the new section
			var MC:MovieClip	= MovieClip(e.currentTarget);
			showLoader(MC.num);
		}
		
		// TRACK THE MOUSE POSITION
		private function trackMouse(MC:MovieClip, b:Boolean=true):void
		{
			// if b is true then start loop for tracking mouse position
			// else stop loop and set the movies position back to normal
			if (b)	MC.addEventListener( Event.ENTER_FRAME, trackMousePos );
			else
			{
				MC.removeEventListener( Event.ENTER_FRAME, trackMousePos );
				TweenMax.to(MC, .5, { y: MC.oy, ease: Circ.easeOut });
			}
		}
		
		private function trackMousePos(e:Event):void
		{
			// track mouse position and use this as a factor to
			// a slight movement when rolling over this movie
			var MC:MovieClip	= MovieClip(e.currentTarget);
			var mY:Number		= MC.parent.mouseY;
			var posY:Number		= (mY/10) + MC.oy;
			MC.y				+= (posY - MC.y)/5;
		}
		
		
		
		
		
		// GET A NEW SECTION OF CONTENT
		// THIS IS CALLED BY A NUMBER REFERENCE LINKING BACK TO THE MAIN XML CONTENT
		// THE NUMBER IS STORED IN THE MOVIECLIP OF THE MENU ITEM THAT WAS CLICKED
		private function getSection(num:int):void
		{
			// remove old content
			destroyContent();
			
			// get section content using the num reference to get the point in the XML
			// where our new content is
			var xmlList:XMLList		= __xmlContent[num].item;
			
			// get total amount of images to load for this section
			__imgsToLoad		= xmlList.length();
			
			// loop through and start to load the images
			for (var i:uint=0; i<__imgsToLoad; i++)
			{
				// create holder movie for content
				loadImage(xmlList[i], i);
			}
			
			// set the amount of items in this section and setup the iPhone movie
			__iPhone.total		= xmlList.length();
		}
		
		
		
		
		
		// LOAD THE CONTENT IMAGES
		private function loadImage(xml:XML, num:int):void
		{
			// create loader class and add it to the main loaders array
			var l:Loader	= loader(xml.@src, checkTotalImagesLoaded);
			__loaders.push(l);
			
			// add to display and position based on the num reference and the width specified for the iPhone interface
			l.x		= num * __iPhone.width;
			__iPhone.contentMC.addChild(l);
		}
		
		// CHECK TO SEE IF ALL THE CONTENT IMAGES HAVE BEEN LOADED,
		// IF THEY HAVE THEN SETUP THE DRAG AND THROW FUNCTIONALITY
		private function checkTotalImagesLoaded(e:Event=null):void
		{
			// check that all the images have loaded, if so then hide the loader and show the content
			__imgsLoaded++;
			if (__imgsLoaded == __imgsToLoad)
			{
				// hide loader
				hideLoader();
				
				// setup iphone
				__iPhone.setup();
			}
		}
		
		// LOADER METHODS
		// SHOW THE IPHONE STYLE LOADER WHILST CONETNT IS BEING LOADED
		private function showLoader(num:int=0):void
		{
			hideMenu();
			TweenMax.to(loaderMC, .5, { alpha: 1, visible: true, onComplete: getSection, onCompleteParams: [num] });
		}
		
		// HIDE PRELOADER
		private function hideLoader():void
		{
			TweenMax.to(loaderMC, .5, { alpha: 0, visible: false });
		}
		
		
		
		
		
		// REQUEST AN XML FILE TO LOAD
		private function loadXML(file:String, CBFunc:Function):void
		{			
			var urlLoader:URLLoader = new URLLoader( new URLRequest(file) );
			urlLoader.addEventListener( IOErrorEvent.IO_ERROR, onError );
			urlLoader.addEventListener( Event.COMPLETE, CBFunc );
		}
		
		// LOADER METHOD FOR LOADING ANY TYPE OF CONTENT
		private function loader(file:String, CBFunc:Function=null, ProgressFunc:Function=null):Loader
		{
			var l:Loader	= new Loader();
			if (CBFunc != null) l.contentLoaderInfo.addEventListener( Event.INIT, CBFunc );
			if (ProgressFunc != null) l.contentLoaderInfo.addEventListener( ProgressEvent.PROGRESS, ProgressFunc );
			l.contentLoaderInfo.addEventListener( IOErrorEvent.IO_ERROR, onError );
			l.load( new URLRequest(file) );
			return l;
		}
		
		// ERROR LISTENER
		private function onError(e:ErrorEvent):void
		{
			// catch all loading errors
			trace("error loading content : " + e + " : " + e.target + " : " + e.target.toString());
		}
		
		
		
		// CHECK IF THE SCREEN HAS BEEN RESIZED AND REFLOW THE CONTENT
		private function resizeHandler(e:Event=null):void
		{
			// center the iphone movie in the middle of the screen
			iPhoneMC.x		= stage.stageWidth/2;
			iPhoneMC.y		= stage.stageHeight/2;
		}
		
		// KILL ALL LOADED CONTENT AND REMOVE FROM MEMORY
		private function destroyContent(e:Event=null):void
		{
			// reset values for images to load and total number of images loaded
			__imgsToLoad	= 0;
			__imgsLoaded	= 0;
			
			// loop through all loaded assets
			if (__loaders.length > 0) for (var i:uint=0; i<__loaders.length; i++)
			{
				// remove asset from its display list and then unload and stop the content ready for removal from memory
				__loaders[i].parent.removeChild(__loaders[i]);
				__loaders[i].unload();
			}
			
			// reset the main loaders array
			__loaders		= [];
		}
		
		
		
		
		
		// ______________________________________________
		// GETTERS & SETTERS
		
		public function get iPhoneMC():MovieClip
		{
			return iPhone_mc;
		}
		
		public function get menuMC():MovieClip
		{
			return iPhone_mc.menu_mc;
		}
		
		public function get loaderMC():MovieClip
		{
			return iPhone_mc.loader_mc;
		}
		
		public function get iPhoneBkgdMC():MovieClip
		{
			return iPhone_mc.bkgd_mc;
		}
	}
}